/*
 * Copyright (c) 2009.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

package uk.me.parabola.splitter;

import java.util.List;

public interface SplittableArea {
	/**
	 * @return the area that this splittable area represents
	 */
	Area getBounds();

	/**
	 * @param maxNodes the maximum number of nodes per area
	 * @return a list of areas, each containing no more than {@code maxNodes} nodes.
	 * Each area returned must be aligned to the appropriate overview map resolution.
	 */
	List<Area> split(long maxNodes);
	
	List<Area> split(long maxNodes, java.awt.geom.Area polygonArea);
	
	boolean hasData();
	
	void setTrim(boolean trim);

	void setMapId(int mapId);
}
